moSetGetMapObjects = {};

function moSetGetMapObjects:searchFirstMapObjects(self)
	moMapObjects = {};
	moMapShops = {};
	moAnimalMapObjects = {};
	moBgaMapObjects = {};
	moBgaMapObjects.silo = 0;
	moBgaMapObjects.catcher = 0;
	moBgaMapObjects.bgaExtension = false;
	moBgaMapObjects.silageExtension = false;	
	local fs = 0;
	local sh = 0;
	--local bga = 0;
	local animalNr = 0;
	if g_currentMission.onCreateLoadedObjects ~= nil then		
		for k, onCreateObject in pairs(g_currentMission.onCreateLoadedObjects) do								
			if onCreateObject.fremdObject ~= nil and onCreateObject.Points ~= nil then				
				if onCreateObject.WoolPaletteCollectorDirtyFlag then 					
					moMapObjects["woolsheepPalCollector"] = {};				
					moMapObjects["woolsheepPalCollector"].objCreate = onCreateObject;
				end;
				if onCreateObject.PalettenSammlerDirtyFlag then					
					if getUserAttribute ~= nil and onCreateObject.nodeID ~= nil then						
						local factoryName = Utils.getNoNil(getUserAttribute(onCreateObject.nodeID, "factoryName"), false); --factoryName
						if factoryName ~= nil and factoryName ~= false then
							local factoryNameTemp = string.lower(factoryName);							
							moMapObjects[factoryNameTemp.. "PalCollector"] = {};
							moMapObjects[factoryNameTemp.. "PalCollector"].objCreate = onCreateObject;
						end;
					end;
				end;
			end;
			if not moDefault.watermod and onCreateObject.Needs ~= nil then				
				moDefault.watermod = true;				
			end;			
			if onCreateObject.improvedSilageBunkerInitDone ~= nil and not moBgaMapObjects.silageExtension then
				moBgaMapObjects.silageExtension = true;								
			end;
			local foundName = false;
			if onCreateObject.name ~= nil then				
				local tempName = string.lower(string.gsub(onCreateObject.name, " ", ""));				
				for a=1, moDefaultPlaceableObjects.mapObjectsSearch do
					if string.find(tempName, moDefaultPlaceableObjects.mapObjectsName[a]) then 
						moDefaultPlaceableObjects.mapObjectsStatus[a] = onCreateObject;
						foundName = true;
					end;
				end;
			end;			
			if onCreateObject.FabrikScriptDirtyFlag ~= nil and not foundName then				
				fs = fs+1;
				moDefaultPlaceableObjects.mapObjectsFsSearch = moDefaultPlaceableObjects.mapObjectsFsSearch+1;
				moDefaultPlaceableObjects.mapObjectsFsStatus[fs] = onCreateObject;
				moDefaultPlaceableObjects.mapObjectsFsName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = unpack(moLanguage.extern["fabrik".. moDefault.language]).. "_".. fs;
				--local modName = getUserAttribute(onCreateObject.nodeId, "onCreate"); --factoryName
				if getUserAttribute ~= nil and onCreateObject.nodeId ~= nil then
					local factoryName = Utils.getNoNil(getUserAttribute(onCreateObject.nodeId, "factoryName"), false); --factoryName				
					if factoryName ~= nil and factoryName ~= false then
						moDefaultPlaceableObjects.mapObjectsFsName[fs] = string.lower(factoryName);	
						moDefaultPlaceableObjects.mapObjectsFsAttributName[fs] = factoryName;						
					end;
				end;
			end;
			--if onCreateObject.ViehMarktDirtyFlag ~= nil then
			--	moDefault.viehmarkt = true;
			--	if onCreateObject.fillTypes ~= nil and onCreateObject.priceMultipliers ~= nil then
			--		sh = sh+1;
			--		moDefaultPlaceableStation.mapShopSearch = moDefaultPlaceableStation.mapShopSearch+1;
			--		moDefaultPlaceableStation.mapShopStatus[sh] = onCreateObject;
			--		moDefaultPlaceableStation.mapShopMod[sh] = "viehmarkt";
			--		moDefaultPlaceableStation.mapShopName[sh] = unpack(moLanguage.extern["viehmarkt".. moDefault.language]);
			--	end;				
			--end;
			if onCreateObject.stationName == "BunkerSilo" and onCreateObject.bunkerSilo then				
				moBgaMapObjects.silo = moBgaMapObjects.silo+1
				moBgaMapObjects["silo".. moBgaMapObjects.silo] = {};
				moBgaMapObjects["silo".. moBgaMapObjects.silo].obj = onCreateObject.bunkerSilo;
				moBgaMapObjects["silo".. moBgaMapObjects.silo].objCreate = onCreateObject;
				if getUserAttribute ~= nil and onCreateObject.bunkerSilo.nodeId ~= nil then
					local silageSiloName = Utils.getNoNil(getUserAttribute(onCreateObject.bunkerSilo.nodeId, "silageSiloName"), nil); --factoryName
					if silageSiloName ~= nil then
						moBgaMapObjects["silo".. moBgaMapObjects.silo].siloName = silageSiloName;
					end;
				end;
			end;
			if onCreateObject.bunkerUseTime and onCreateObject.bunkerFillLevel then
				moBgaMapObjects.catcher = moBgaMapObjects.catcher+1;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher] = {};
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = false;
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].obj = onCreateObject.tipTriggers[1]; --g_currentMission.onCreateLoadedObjects[onCreateObject.id];
				moBgaMapObjects["catcher".. moBgaMapObjects.catcher].objCreate = onCreateObject;								
				if onCreateObject.fermenter_TS_clog or onCreateObject.BGA_Bonus ~= nil then					
					moBgaMapObjects["catcher".. moBgaMapObjects.catcher].bgaExtension = true;
					moBgaMapObjects.bgaExtension = true;					
				end;
			end;
			if onCreateObject.SchweineZuchtDirtyFlag ~= nil then
				animalNr = animalNr+1;
				moAnimalMapObjects[animalNr] = {};
				moAnimalMapObjects[animalNr].objCreate = onCreateObject;				
				if onCreateObject.animal ~= nil then
					if not string.find(moDefault.foundAnimals, onCreateObject.animal.. " ") then
						moDefault.foundAnimals = moDefault.foundAnimals.. tostring(onCreateObject.animal).. " ";
					end;					
				end;				
			end;
			if onCreateObject.SiloBuyAuto ~= nil then
				--AllInOnSilo;
			end;			
		end;
	end;	
end;